//
//  main.swift
//  AudioKit
//
//  Created by Aurelius Prochazka on 2/20/15.
//  Copyright (c) 2015 Aurelius Prochazka. All rights reserved.
//

import Foundation

let testDuration: Float = 10.0

class Instrument : AKInstrument {
    
    var auxilliaryOutput = AKAudio()
    
    override init() {
        super.init()
        
        let filename = "CsoundLib64.framework/Sounds/808loop.wav"
        let audio = AKFileInput(filename: filename)
        let mono = AKMix(monoAudioFromStereoInput: audio)
        
        let stereoImpulse = "CsoundLib64.framework/Sounds/shortpianohits.aif"
        
        let dishConvolution  = AKStereoConvolution(
            input: mono.scaledBy(0.5.ak),
            impulseResponseFilename: stereoImpulse
        )
        setStereoAudioOutput(dishConvolution)
    }
}

AKOrchestra.testForDuration(testDuration)

let instrument = Instrument()
AKOrchestra.addInstrument(instrument)

instrument.play()

let manager = AKManager.sharedManager()
while(manager.isRunning) {} //do nothing
println("Test complete!")
